package com.ruoyi.web.controller.coffee;

import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.framework.web.service.WeixinServiceImpl;
import com.ruoyi.system.mapper.GoodsSkuMapper;
import com.ruoyi.system.service.impl.AppServiceImpl;
import com.ruoyi.system.service.impl.GoodsServiceImpl;
import com.ruoyi.system.service.impl.OrderTakingServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@RestController
@RequestMapping("/weixin")
public class WeixinController {

    @Autowired
    WeixinServiceImpl weixinService;
    @Autowired
    private AppServiceImpl appService;
    @Autowired
    private OrderTakingServiceImpl orderTakingService;
    @Autowired
    private GoodsServiceImpl goodsService;

    //这个就是那个使用传code进来的接口
    @PostMapping("/login")
    public AjaxResult login(@RequestBody String body){
        JSONObject param = JSONObject.parseObject(body);
        String code =param.getString("code");
        String encryptedData = param.getString("encryptedData");
        String iv = param.getString("iv");
        String source = param.getString("source");

        AjaxResult ajax = AjaxResult.success();
        String token = weixinService.login(code,encryptedData,iv,source);
        ajax.put(Constants.TOKEN, token);
        return ajax;
    }

    @RequestMapping("/wxNotify")
    public void wxNotify(HttpServletRequest request,HttpServletResponse response){
        try{
            weixinService.wxNotify(request,response);
        }catch (Exception e){
            throw new ServiceException("微信回调发生异常");
        }
    }
    @RequestMapping("/test")
    public String test(){
        return goodsService.test();
    }

    @RequestMapping("/getShop")
    public AjaxResult getShop(@RequestParam(required = false) String lng,@RequestParam(required = false)String lat){
        return AjaxResult.success(appService.getShop(lng,lat));
    }


    @GetMapping(value = "/infoByShop")
    public AjaxResult infoByShop(String shopId)
    {
        return AjaxResult.success(orderTakingService.getInfoByShop(shopId));
    }


}
